/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/*
 *  Copyright (C) 2008 OMC Denmark ApS.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef __IMAPIFORMCONTAINERS_IMPL_H_
#define __IMAPIFORMCONTAINERS_IMPL_H_

#include "IMAPIFormContainerS.h"
#include "utils/macros.h"

#define MAPIGUID_H // do not include mapiguid.h
#include <mapix.h>
#include <mapiform.h>

#include "Brutus_Loader_Impl_Export.h"

class Brutus_Loader_Impl_Export BRUTUS_IMAPIFormContainer_i : public virtual POA_BRUTUS::IMAPIFormContainer,
							      public virtual ::PortableServer::RefCountServantBase
{
public:
	//Constructor
	BRUTUS_IMAPIFormContainer_i(LPMAPIFORMCONTAINER MAPIFormContainer,
				    LPMAPISESSION MAPISession,
				    ::PortableServer::POA_ptr Poa);

	virtual ::BRUTUS::BRESULT InstallForm(::BRUTUS::BDEFINE ulFlags,
					      const char * szCfgPathName);

	virtual ::BRUTUS::BRESULT RemoveForm(const char * szMessageClass);

	virtual ::BRUTUS::BRESULT ResolveMessageClass(const char * szMessageClass,
						      ::BRUTUS::BDEFINE ulFlags,
						      ::BRUTUS::IMAPIFormInfo_out pforminfo);

	virtual ::BRUTUS::BRESULT ResolveMultipleMessageClasses(const ::BRUTUS::seq_string & pMsgClassArray,
								::BRUTUS::BDEFINE ulFlags,
								::BRUTUS::seq_IMAPIFormInfo_out ppfrminfoarray);

	virtual ::BRUTUS::BRESULT CalcFormPropSet(::BRUTUS::BDEFINE ulFlags,
						  ::BRUTUS::SMAPIFormPropArray_out ppResults);

	virtual ::BRUTUS::BRESULT GetDisplay(::BRUTUS::BDEFINE ulFlags,
					     ::CORBA::String_out pszDisplayName);

	virtual ::BRUTUS::BRESULT QueryInterface(const char *iid,
						 ::BRUTUS::IUnknown_out ppvObject);

	virtual void Destroy(::CORBA::ULong InstanceID);

private:
	BRUTUS_IMAPIFormContainer_i(void)
	{ };

	//Destructor
	virtual ~BRUTUS_IMAPIFormContainer_i(void)
	{
		try {
			mapi_form_container_->Release();
			mapi_session_->Release();
		}
		catch (...) {
			BRUTUS_LOG_ERR("Exception caught");
		}
	};

	LPMAPIFORMCONTAINER mapi_form_container_;
	LPMAPISESSION mapi_session_;
	::PortableServer::POA_var poa_;

	ACE_RW_Mutex mutex_;

};


#endif /* __IMAPIFORMCONTAINERS_IMPL_H_  */
